1345:跳跃游戏 IV

This commit is contained in:
轩辕龙儿 2022-01-21 16:08:30 +08:00
parent eda8df3da4
commit 8278f88a2b
2 changed files with 181 additions and 0 deletions

View File

@ -0,0 +1,123 @@
//给你一个整数数组 arr 你一开始在数组的第一个元素处下标为 0
//
// 每一步你可以从下标 i 跳到下标
//
//
// i + 1 满足i + 1 < arr.length
// i - 1 满足i - 1 >= 0
// j 满足arr[i] == arr[j] i != j
//
//
// 请你返回到达数组最后一个元素的下标处所需的 最少操作次数
//
// 注意任何时候你都不能跳到数组外面
//
//
//
// 示例 1
//
// 输入arr = [100,-23,-23,404,100,23,23,23,3,404]
//输出3
//解释那你需要跳跃 3 下标依次为 0 --> 4 --> 3 --> 9 下标 9 为数组的最后一个元素的下标
//
//
// 示例 2
//
// 输入arr = [7]
//输出0
//解释一开始就在最后一个元素处所以你不需要跳跃
//
//
// 示例 3
//
// 输入arr = [7,6,9,6,9,6,9,7]
//输出1
//解释你可以直接从下标 0 处跳到下标 7 也就是数组的最后一个元素处
//
//
// 示例 4
//
// 输入arr = [6,1,9]
//输出2
//
//
// 示例 5
//
// 输入arr = [11,22,7,7,7,7,7,7,7,22,13]
//输出3
//
//
//
//
// 提示
//
//
// 1 <= arr.length <= 5 * 10^4
// -10^8 <= arr[i] <= 10^8
//
// Related Topics 广度优先搜索 数组 哈希表 👍 140 👎 0
package leetcode.editor.cn;
import java.util.*;
//1345:跳跃游戏 IV
public class JumpGameIv {
public static void main(String[] args) {
Solution solution = new JumpGameIv().new Solution();
// TO TEST
solution.minJumps(new int[]{100,-23,-23,404,100,23,23,23,3,404});
}
//leetcode submit region begin(Prohibit modification and deletion)
class Solution {
public int minJumps(int[] arr) {
if (arr.length == 1) {
return 0;
}
boolean[] use = new boolean[arr.length];
Map<Integer, List<Integer>> map = new HashMap<>();
for (int i = 0; i < arr.length; i++) {
map.computeIfAbsent(arr[i], k -> new ArrayList<>()).add(i);
}
use[0] = true;
Queue<Integer> queue = new ArrayDeque<>();
queue.add(0);
int count = 0;
while (!queue.isEmpty()) {
int size = queue.size();
count++;
for (int i = 0; i < size; i++) {
int index = queue.poll();
if (index - 1 >= 0 && !use[index - 1]) {
queue.add(index - 1);
use[index - 1] = true;
}
if (index + 1 == arr.length - 1) {
return count;
}
if (index + 1 >= 0 && !use[index + 1]) {
queue.add(index + 1);
use[index + 1] = true;
}
if (map.containsKey(arr[index])) {
List<Integer> list = map.get(arr[index]);
map.remove(arr[index]);
for (int ind : list) {
if (ind == arr.length - 1) {
return count;
}
if (!use[ind]) {
queue.add(ind);
use[ind] = true;
}
}
}
}
}
return 0;
}
}
//leetcode submit region end(Prohibit modification and deletion)
}

View File

@ -0,0 +1,58 @@
<p>给你一个整数数组&nbsp;<code>arr</code>&nbsp;,你一开始在数组的第一个元素处(下标为 0</p>
<p>每一步,你可以从下标&nbsp;<code>i</code>&nbsp;跳到下标:</p>
<ul>
<li><code>i + 1</code>&nbsp;满足:<code>i + 1 &lt; arr.length</code></li>
<li><code>i - 1</code>&nbsp;满足:<code>i - 1 &gt;= 0</code></li>
<li><code>j</code>&nbsp;满足:<code>arr[i] == arr[j]</code>&nbsp;&nbsp;<code>i != j</code></li>
</ul>
<p>请你返回到达数组最后一个元素的下标处所需的&nbsp;<strong>最少操作次数</strong>&nbsp;</p>
<p>注意:任何时候你都不能跳到数组外面。</p>
<p>&nbsp;</p>
<p><strong>示例 1</strong></p>
<pre><strong>输入:</strong>arr = [100,-23,-23,404,100,23,23,23,3,404]
<strong>输出:</strong>3
<strong>解释:</strong>那你需要跳跃 3 次,下标依次为 0 --&gt; 4 --&gt; 3 --&gt; 9 。下标 9 为数组的最后一个元素的下标。
</pre>
<p><strong>示例 2</strong></p>
<pre><strong>输入:</strong>arr = [7]
<strong>输出:</strong>0
<strong>解释:</strong>一开始就在最后一个元素处,所以你不需要跳跃。
</pre>
<p><strong>示例 3</strong></p>
<pre><strong>输入:</strong>arr = [7,6,9,6,9,6,9,7]
<strong>输出:</strong>1
<strong>解释:</strong>你可以直接从下标 0 处跳到下标 7 处,也就是数组的最后一个元素处。
</pre>
<p><strong>示例 4</strong></p>
<pre><strong>输入:</strong>arr = [6,1,9]
<strong>输出:</strong>2
</pre>
<p><strong>示例 5</strong></p>
<pre><strong>输入:</strong>arr = [11,22,7,7,7,7,7,7,7,22,13]
<strong>输出:</strong>3
</pre>
<p>&nbsp;</p>
<p><strong>提示:</strong></p>
<ul>
<li><code>1 &lt;= arr.length &lt;= 5 * 10^4</code></li>
<li><code>-10^8 &lt;= arr[i] &lt;= 10^8</code></li>
</ul>
<div><div>Related Topics</div><div><li>广度优先搜索</li><li>数组</li><li>哈希表</li></div></div><br><div><li>👍 140</li><li>👎 0</li></div>